
/*
 * This file was generated by the SOM Compiler.
 * FileName: DM2Setup.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter emith: 1.11
 */

/*
 * 
 * 
 *      DM2Setup.CSC - DeskMan/2 setup object.
 * 
 *   Ŀ
 *     DM2Setup object - setup string manipulation methods.               
 *                       Part of DeskMan/2.                               
 *                                                                        
 *     (C) Copyright 1993-1994 Development Technologies, Inc.             
 *         Portions Copyright 1993 Gregory Czaja                          
 *         All rights reserved                                            
 *         DeskMan, DeskMan/2, DM2Setup, VUEMan, VUEMan/2 and DM2Image    
 *         are trademarks of Development Technologies, Inc. (DevTech),    
 *         a Pennsylvania Corporation                                     
 *                                                                        
 *     version 1: initial release                          November 1993  
 *   
 */


#ifndef DM2Setup_h
#define DM2Setup_h

#include <som.h>

/*
 * Define the class name as an object type
 */
#ifndef DM2Setup
#define DM2Setup SOMAny
#endif
#include "wptrans.h"

/*
 * Passthru lines: File: "C.h", "after"
 */
/* public defs for DM2Setup */

#define DM2Setup_MajorVersion 1
#define DM2Setup_MinorVersion 1

#define  NO_ERROR                   0
#define  ERROR_BUFFER_OVERFLOW      1
#define  ERROR_NO_ITEMS             2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define DM2SetupNewClass DM2Setupc
#pragma linkage(DM2Setupc, system)
#define DM2SetupClassData DM2Setupd
#define DM2SetupCClassData DM2Setupx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define DM2Setup_classObj DM2SetupClassData.classObject
#define _DM2Setup DM2Setup_classObj

/*
 * New and Renew macros for DM2Setup
 */
#define _DM2SetupNew() (_somNew(DM2SetupClassData.classObject))
#define DM2SetupNew() \
	( DM2SetupClassData.classObject \
		? _DM2SetupNew() \
		: ( DM2SetupNewClass(DM2Setup_MajorVersion, DM2Setup_MinorVersion), _DM2SetupNew() ) )
#define DM2SetupRenew(buf) \
	( _somRenew(DM2SetupClassData.classObject, buf) )

/*
 * Override method: wpInitData
 */
#define DM2Setup_wpInitData(somSelf) \
	WPObject_wpInitData(somSelf)

/*
 * Override method: wpUnInitData
 */
#define DM2Setup_wpUnInitData(somSelf) \
	WPObject_wpUnInitData(somSelf)

/*
 * New Method: reset
 *
 * Reset the setup string buffer
 */
typedef APIRET    SOMLINK somTP_DM2Setup_reset(DM2Setup *somSelf);
#pragma linkage(somTP_DM2Setup_reset, system)
typedef somTP_DM2Setup_reset *somTD_DM2Setup_reset;
#define somMD_DM2Setup_reset "----"
#define DM2Setup_reset(somSelf) \
    (SOM_Resolve(somSelf, DM2Setup, reset) \
	(somSelf))
#define _reset DM2Setup_reset

/*
 * New Method: addSetup
 *
 * add a setup keyword/value pair to the setup buffer
 * Note: does not require the "=" (eqaul sign nor the trailing ";"
 */
typedef APIRET    SOMLINK somTP_DM2Setup_addSetup(DM2Setup *somSelf,
		const char *key,
		const char *value);
#pragma linkage(somTP_DM2Setup_addSetup, system)
typedef somTP_DM2Setup_addSetup *somTD_DM2Setup_addSetup;
#define somMD_DM2Setup_addSetup "----"
#define DM2Setup_addSetup(somSelf,key,value) \
    (SOM_Resolve(somSelf, DM2Setup, addSetup) \
	(somSelf,key,value))
#define _addSetup DM2Setup_addSetup

/*
 * New Method: querySetupLength
 *
 * Query the string length to hold a specific setup string from buffer
 */
typedef ULONG    SOMLINK somTP_DM2Setup_querySetupLength(DM2Setup *somSelf,
		const char *key);
#pragma linkage(somTP_DM2Setup_querySetupLength, system)
typedef somTP_DM2Setup_querySetupLength *somTD_DM2Setup_querySetupLength;
#define somMD_DM2Setup_querySetupLength "----"
#define DM2Setup_querySetupLength(somSelf,key) \
    (SOM_Resolve(somSelf, DM2Setup, querySetupLength) \
	(somSelf,key))
#define _querySetupLength DM2Setup_querySetupLength

/*
 * New Method: querySetup
 *
 * Copy the value for a specific setup string from the buffer
 */
typedef APIRET    SOMLINK somTP_DM2Setup_querySetup(DM2Setup *somSelf,
		const char *key,
		ULONG bufLen,
		char *valueBuf);
#pragma linkage(somTP_DM2Setup_querySetup, system)
typedef somTP_DM2Setup_querySetup *somTD_DM2Setup_querySetup;
#define somMD_DM2Setup_querySetup "----"
#define DM2Setup_querySetup(somSelf,key,bufLen,valueBuf) \
    (SOM_Resolve(somSelf, DM2Setup, querySetup) \
	(somSelf,key,bufLen,valueBuf))
#define _querySetup DM2Setup_querySetup

/*
 * New Method: queryLength
 *
 * Return the size of the buffer to hold the entire setup string
 */
typedef ULONG    SOMLINK somTP_DM2Setup_queryLength(DM2Setup *somSelf);
#pragma linkage(somTP_DM2Setup_queryLength, system)
typedef somTP_DM2Setup_queryLength *somTD_DM2Setup_queryLength;
#define somMD_DM2Setup_queryLength "----"
#define DM2Setup_queryLength(somSelf) \
    (SOM_Resolve(somSelf, DM2Setup, queryLength) \
	(somSelf))
#define _queryLength DM2Setup_queryLength

/*
 * New Method: queryString
 *
 * Copy the accumulated setup string from the setup buffer to the 
 * caller's buffer
 */
typedef APIRET    SOMLINK somTP_DM2Setup_queryString(DM2Setup *somSelf,
		ULONG bufLen,
		char *pBuffer);
#pragma linkage(somTP_DM2Setup_queryString, system)
typedef somTP_DM2Setup_queryString *somTD_DM2Setup_queryString;
#define somMD_DM2Setup_queryString "----"
#define DM2Setup_queryString(somSelf,bufLen,pBuffer) \
    (SOM_Resolve(somSelf, DM2Setup, queryString) \
	(somSelf,bufLen,pBuffer))
#define _queryString DM2Setup_queryString

/*
 * New Method: fromString
 *
 * Set the buffer to the sepcific setup value
 * Note: the setup string needs to be complete, including "="s and ";"s
 * Note: it will destroy the previous contents of the buffer
 */
typedef APIRET    SOMLINK somTP_DM2Setup_fromString(DM2Setup *somSelf,
		const char *setup);
#pragma linkage(somTP_DM2Setup_fromString, system)
typedef somTP_DM2Setup_fromString *somTD_DM2Setup_fromString;
#define somMD_DM2Setup_fromString "----"
#define DM2Setup_fromString(somSelf,setup) \
    (SOM_Resolve(somSelf, DM2Setup, fromString) \
	(somSelf,setup))
#define _fromString DM2Setup_fromString

/*
 * New Method: queryBuffer
 *
 * Return the setup buffer address
 */
typedef const char *   SOMLINK somTP_DM2Setup_queryBuffer(DM2Setup *somSelf);
#pragma linkage(somTP_DM2Setup_queryBuffer, system)
typedef somTP_DM2Setup_queryBuffer *somTD_DM2Setup_queryBuffer;
#define somMD_DM2Setup_queryBuffer "----"
#define DM2Setup_queryBuffer(somSelf) \
    (SOM_Resolve(somSelf, DM2Setup, queryBuffer) \
	(somSelf))
#define _queryBuffer DM2Setup_queryBuffer

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK DM2SetupNewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(DM2SetupNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct DM2SetupClassDataStructure {
	SOMAny *classObject;
	somMToken reset;
	somMToken addSetup;
	somMToken querySetupLength;
	somMToken querySetup;
	somMToken queryLength;
	somMToken queryString;
	somMToken fromString;
	somMToken queryBuffer;
} DM2SetupClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct DM2SetupCClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} DM2SetupCClassData;

#endif       /* DM2Setup_h */

/*
 * This file was generated by the SOM Compiler.
 * FileName: DM2Setup.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter emith: 1.11
 */

#ifndef DM2Setup_mh
#define DM2Setup_mh


/*
 * Define the class name as an object type
 */
#ifndef M_DM2Setup
#define M_DM2Setup SOMAny
#endif

#define M_DM2Setup_MajorVersion 1
#define M_DM2Setup_MinorVersion 1

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_DM2SetupNewClass DM2Setupc
#pragma linkage(DM2Setupc, system)
#define M_DM2SetupClassData DM2Setupd
#define M_DM2SetupCClassData DM2Setupx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_DM2Setup_classObj M_DM2SetupClassData.classObject
#define _M_DM2Setup M_DM2Setup_classObj

/*
 * New and Renew macros for M_DM2Setup
 */
#define _M_DM2SetupNew() (_somNew(M_DM2SetupClassData.classObject))
#define M_DM2SetupNew() \
	( M_DM2SetupClassData.classObject \
		? _M_DM2SetupNew() \
		: ( M_DM2SetupNewClass(M_DM2Setup_MajorVersion, M_DM2Setup_MinorVersion), _M_DM2SetupNew() ) )
#define M_DM2SetupRenew(buf) \
	( _somRenew(M_DM2SetupClassData.classObject, buf) )

/*
 * Override method: wpclsInitData
 */
#define M_DM2Setup_wpclsInitData(somSelf) \
	M_WPObject_wpclsInitData(somSelf)

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK M_DM2SetupNewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(M_DM2SetupNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_DM2SetupClassDataStructure {
	SOMAny *classObject;
} M_DM2SetupClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_DM2SetupCClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} M_DM2SetupCClassData;

#endif       /* DM2Setup_h */
